## unionfs-1.3.tar.gz

=== Makefile ===
# Makefile for the Linux 2.6 unionfs

# this should point to where your kernel headers are
KVERS?=$(shell uname -r)
MODDIR= /lib/modules/$(KVERS)
LINUXSRC = /lib/modules/$(KVERS)/build
TOPINC   = -I${LINUXSRC}/include
# This is where the make install target will put stuff
PREFIX   = /usr/local
MANDIR   = ${PREFIX}/man
MODPREFIX=
VERSION  = 1.3
SUP_MAJOR= 2
SUP_MINOR= 6
SUP_PATCH= 17
SUP_EXTRA=
TAROPTS = czvf
COMPEXT = .gz
UNIONFS_DEBUG_CFLAG = -g
UNIONFS_OPT_CFLAG= -O2
UNIONFS_VERSION_CFLAG=-DUNIONFS_VERSION=\"${VERSION}\" -DSUP_MAJOR=${SUP_MAJOR} -DSUP_MINOR=${SUP_MINOR} -DSUP_PATCH=${SUP_PATCH}

# allow custmom override of TOPINC for fistgen developers
# These options enable extended attribute support
#  EXTRACFLAGS=-DUNIONFS_XATTR
# Some kernels also require FIST_SETXATTR_CONSTVOID
#  EXTRACFLAGS=-DUNIONFS_XATTR -DFIST_SETXATTR_CONSTVOID
ifneq ($(FISTDEVMK),)
-include $(FISTDEVMK)
else
-include fistdev.mk
endif

CC	= gcc
KERNELVERSION=$(shell echo $(KVERS) | cut -d. -f1,2)
EXTRA_CFLAGS += ${TOPINC} -Wall -Werror ${EXTRACFLAGS} ${UNIONFS_DEBUG_CFLAG} ${UNIONFS_OPT_CFLAG} ${UNIONFS_VERSION_CFLAG}
UCFLAGS = -I. ${UNIONFS_DEBUG_CFLAG} ${UNIONFS_OPT_CFLAG} -Wall -Werror ${EXTRAUCFLAGS}  ${UNIONFS_VERSION_CFLAG}

obj-m := unionfs.o
unionfs-objs := subr.o dentry.o file.o inode.o main.o super.o \
	stale_inode.o branchman.o xattr.o rdstate.o copyup.o  \
	dirhelper.o rename.o unlink.o lookup.o persistent_inode.o \
	commonfops.o dirfops.o print.o malloc_debug.o mmap.o

all:	readthereadme unionfs.ko utils

readthereadme:
	@echo "******************************************************************************"
	@echo "If you have questions about or problems building Unionfs, please read INSTALL."
	@echo "******************************************************************************"
	@echo ""

unionfs.ko: FRC
	make -C ${LINUXSRC} SUBDIRS=$(PWD) FISTDEVMK=$(PWD)/fistdev.mk modules

FRC:

${obj-m}: ${unionfs-objs}
	${LD} -o ${obj-m} -r ${unionfs-objs}

memtest:
	perl match-malloc.pl log.txt

TAGS: $(wildcard *.[ch])
	etags -t $^

tags: $(wildcard *.[ch])
	ctags $^

clean:
	-make -C ${LINUXSRC} SUBDIRS=$(PWD) FISTDEVMK=$(PWD)/fistdev.mk clean
	rm -f ${unionfs-objs} ${obj-m} ${obj-m:.o=.ko} *.d .*.flags \#* *~
	rm -f TAGS tags
	rm -f unionfs-${VERSION}.tar${COMPEXT}
	make -C utils clean

kvers:
	@echo "This Unionfs release supports only Linux kernel version:"
	@echo "${SUP_MAJOR}.${SUP_MINOR}.${SUP_PATCH}${SUP_EXTRA}"

sparse:
	sparse $(patsubst, %.o, %.c, $(unionfs-objs)) ${EXTRA_CFLAGS} -D__KERNEL__

${unionfs-objs}: unionfs.h

utils: FRC
	make -C utils all CC=${CC} UCFLAGS='-I.. ${UCFLAGS}'

install-utils: utils
	make -C utils install PREFIX=${PREFIX}
	mkdir -p ${MANDIR}/man4
	mkdir -p ${MANDIR}/man8
	cp man/unionfs.4 ${MANDIR}/man4
	cp man/unionctl.8 ${MANDIR}/man8
	cp man/uniondbg.8 ${MANDIR}/man8
	cp man/unionimap.8 ${MANDIR}/man8

install-mod: unionfs.ko
	mkdir -p ${MODPREFIX}/${MODDIR}/kernel/fs/unionfs
	cp unionfs.ko ${MODPREFIX}/${MODDIR}/kernel/fs/unionfs
	-/sbin/depmod -a

install: install-utils install-mod

uninstall:
	rm ${MODPREFIX}/${MODDIR}/kernel/fs/unionfs.ko
	-/sbin/depmod -a
	rm ${MANDIR}/man8/unionctl.8
	rm ${MANDIR}/man8/uniondbg.8
	rm ${MANDIR}/man4/unionfs.4
	make -C utils uninstall PREFIX=${PREFIX}

release: unionfs-${VERSION}.tar${COMPEXT}

kernel-source-unionfs-${VERSION}.tar${COMPEXT}:
	mkdir kernel-source-unionfs-${VERSION}
	cp -a Makefile *.h *.c kernel-source-unionfs-${VERSION}
	subst "s/\(^all.*\)\(\${BINS}\)/\1/" kernel-source-unionfs-${VERSION}/Makefile
	tar ${TAROPTS} kernel-source-unionfs-${VERSION}.tar${COMPEXT} kernel-source-unionfs-${VERSION}

unionfs-${VERSION}.tar${COMPEXT}:
	mkdir unionfs-${VERSION}
	cp patch-kernel.sh Makefile.kernel COPYING AUTHORS README INSTALL NEWS BUGS ChangeLog doit.sh undoit.sh Makefile *.[ch] misc/snapmerge misc/match-*.pl unionfs-${VERSION}
	cp -r rpm debian unionfs-${VERSION}
	rm -rf unionfs-${VERSION}/rpm/CVS
	rm -rf unionfs-${VERSION}/debian/CVS
	mkdir unionfs-${VERSION}/regression
	mkdir unionfs-${VERSION}/regression/progs
	mkdir unionfs-${VERSION}/utils
	cp regression/Makefile regression/*.sh regression/ChangeLog regression/scaffold regression/README unionfs-${VERSION}/regression
	cp regression/progs/Makefile regression/progs/*.[ch] unionfs-${VERSION}/regression/progs
	cp utils/Makefile utils/*.[ch] unionfs-${VERSION}/utils
	mkdir unionfs-${VERSION}/man
	cp man/*.[0-9] unionfs-${VERSION}/man
	tar ${TAROPTS} unionfs-${VERSION}.tar${COMPEXT} unionfs-${VERSION}
	rm -rf unionfs-${VERSION}

=== debian/changelog ===
unionfs (1.0.13-1) unstable; urgency=low

  * New upstream release
    + gcc-4.0 fixes (closes: #317687, #318157)
    + needs a build-dependency on uuid-dev
  * added the snapmerge script as example to unionfs-utils (closes: #321273)

 -- Eduard Bloch <blade@debian.org>  Sat,  6 Aug 2005 09:07:39 +0200

unionfs (1.0.11-1) unstable; urgency=low

  * New upstream release (adopted my changes, .diff.gz becoming smaller)
  * added debhelper to unionfs-source build-depends

 -- Eduard Bloch <blade@debian.org>  Fri,  1 Apr 2005 23:02:01 +0200

unionfs (1.0.9-3) unstable; urgency=low

  * added missing build-dep on bzip2 (closes: #301865)
  * added a full stop to the package descriptions (closes: #301872)

 -- Eduard Bloch <blade@debian.org>  Tue, 29 Mar 2005 03:29:34 +0200

unionfs (1.0.9-2) unstable; urgency=low

  * cosmetics, adapted few things from the Morphix debianisation

 -- Eduard Bloch <blade@debian.org>  Mon, 28 Mar 2005 20:51:27 +0200

unionfs (1.0.9-1) unstable; urgency=low

  * Initial Release (closes: #297606)

 -- Eduard Bloch <blade@debian.org>  Sat,  5 Mar 2005 10:01:57 +0100

unionfs (1.0.6-0) unstable; urgency=low

  * modified ndiswrapper debian/ for unionfs

 -- Alex de Landgraaf <alex@delandgraaf.com>  Sun,  9 Jan 2005 17:45:19 +0100

ndiswrapper (0.12+1.0rc1-1) unstable; urgency=low

  * Built for kernel-image-2.6.9.

 -- Andres Salomon <dilinger@voxel.net>  Wed, 29 Dec 2004 03:06:16 -0500

=== debian/control ===
Source: unionfs
Section: misc
Priority: optional
Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 4.0.0), bzip2, uuid-dev
Standards-Version: 3.6.2.1

Package: unionfs-utils
Architecture: any
Recommends: unionfs-source
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: stackable unification file system - management tools
 The unionfs driver provides a unification file system for the Linux
 kernel. It allows to virtually merge the contents of several
 directories and/or stack them, so that apparent file changes in the
 unionfs end in file changes in only one of the source directories.
 .
 This package contains utilities needed to configure unionfs containers
 on-the-fly.

Package: unionfs-source
Architecture: all
Depends: module-assistant, bzip2, debhelper (>> 4.0.0)
Suggests: unionfs-utils
Description: source for the unionfs driver
 The unionfs driver provides a unification file system for the Linux
 kernel. It allows to virtually merge the contents of several
 directories and/or stack them, so that apparent file changes in the
 unionfs end in file changes in only one of the source directories.
 .
 This package contains the module source. The kernel driver can be built from
 it using module-assistant or make-kpkg.

Source: unionfs
Section: misc
Priority: optional
Maintainer: Alex de Landgraaf <alex@delandgraaf.com>
Build-Depends: debhelper (>> 4.1.0), bzip2
Standards-Version: 3.6.1

Package: unionfs-modules-2.6.9
Architecture: i386
Depends: unionfs-utils
Recommends: kernel-image-2.6.9
Provides: unionfs-modules
Description: Unionfs linux kernel module
 This package contains the unionfs loadable kernel modules for the
 kernel-image-2.6.9 package.
 .
 If you compiled a custom kernel, you will most likely need to compile a
 custom version of this module as well. The unionfs-source
 package has been provided for this purpose.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build-arch: configure-stamp  build-arch-stamp
build-arch-stamp:
	dh_testdir
	$(MAKE) utils LINUXSRC=/usr/include
	touch build-arch-stamp

build-indep:  configure-stamp build-indep-stamp
build-indep-stamp:
	dh_testdir
	touch build-indep-stamp

build: build-arch build-indep

clean:
	dh_testdir
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	-$(MAKE) clean
	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install-utils PREFIX=$(CURDIR)/debian/unionfs-utils/usr MANDIR=$(CURDIR)/debian/unionfs-utils/usr/share/man
	tar -v -c --exclude ".svn" --exclude "CVS" --exclude "debian" . | tar x -C debian/unionfs-source/usr/src/modules/unionfs
	cp -a debian/compat debian/*modules.in debian/rules debian/copyright debian/changelog debian/unionfs-source/usr/src/modules/unionfs/debian
	cd debian/unionfs-source/usr/src && tar c modules | bzip2 -9 > unionfs.tar.bz2 && rm -rf modules

	dh_install

binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs ChangeLog -i
	dh_installdocs -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install
	dh_testdir -s
	dh_testroot -s
	dh_installdocs -s
	dh_installchangelogs ChangeLog -s
	dh_installexamples snapmerge -s
	dh_strip -s
	dh_link -s
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

# module-assistant stuff
PACKAGE = unionfs-modules
MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

kdist_clean: prep-deb-files
	dh_clean
	$(MAKE) clean

kdist_config: prep-deb-files
binary-modules: kdist_config
	dh_testdir
	dh_testroot
	dh_clean -k
# build and install the module
	$(MAKE) KVERS=$(KVERS) LINUXSRC=$(KSRC) MODPREFIX=$(CURDIR)/debian/$(PKGNAME)/ install-mod
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure binary-modules kdist kdist_config kdist_image kdist_clean
#!/usr/bin/make -f

#
# Copied from ndiswrapper-source package
#

# module-assistant stuff
PACKAGE = unionfs-modules
MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

kdist_clean: prep-deb-files
	dh_clean
	$(MAKE) clean

kdist_config: prep-deb-files

binary-modules: kdist_config
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs lib/modules/$(KVERS)/misc

# build and install the module
	$(MAKE) KPKG_EXTRAV_ARG=$(KPKG_EXTRAV_ARG) KSRC=$(KSRC) \
	KVER=$(KVERS) \
	INST_DIR=debian/unionfs-modules-$(KVERS)/lib/modules/$(KVERS)/misc/ install

	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)
